## mono 2.10.8.1

=== mcs/Makefile ===
thisdir := .

SUBDIRS := build jay mcs class nunit24 ilasm tools tests errors docs

basic_SUBDIRS := build jay mcs class tools
net_2_0_SUBDIRS := build class nunit24 ilasm tools tests errors mcs
moonlight_raw_SUBDIRS := build class tools mcs
moonlight_SUBDIRS := tools
monodroid_SUBDIRS := build class mcs
monotouch_SUBDIRS := build class mcs
net_3_5_SUBDIRS := build class tools/xbuild
net_4_0_SUBDIRS := build class nunit24 ilasm tools tests errors mcs docs

# List of test subdirs that should pass 100%
centum_tests := \
	class/corlib						\
	class/System						\
	class/System.XML					\
	class/Commons.Xml.Relaxng				\
	class/Cscompmgd						\
	class/Microsoft.JScript					\
	class/Mono.Posix					\
	class/Mono.Security					\
	class/System.Design					\
	class/System.DirectoryServices		\
	class/System.Drawing				\
	class/System.Runtime.Remoting				\
	class/System.Runtime.Serialization.Formatters.Soap	\
	class/System.Security					\
	class/System.ServiceProcess				\
	class/System.Web						\
	class/System.Web.Services				\
	tests							\
	errors

default_centum_tests := \
	$(centum_tests) 	\
	class/System.Data

net_2_0_centum_tests := \
	$(centum_tests)				\
	class/System.Core			\
	class/System.Configuration		\
	class/System.Data.DataSetExtensions	\
	class/System.Xml.Linq			\
	class/System.Transactions		\
	class/Microsoft.Build.Framework		\
	class/Microsoft.Build.Utilities		\
	class/Microsoft.Build.Engine		\
	class/System.Runtime.Serialization	\
	class/System.IdentityModel		\
	class/System.ServiceModel		\
	class/System.ServiceModel.Web		\
	class/Mono.C5

#	class/System.Web.Extensions
#	class/Microsoft.Build.Tasks	

# note that System.Xml.Linq is here to prevent this from being empty
net_3_5_centum_tests := \
	class/System.Xml.Linq

ifdef ONLY_CENTUM_TESTS
TEST_SUBDIRS := $($(PROFILE)_centum_tests)
endif

ifdef TEST_SUBDIRS
$(PROFILE)_SUBDIRS := $(TEST_SUBDIRS)
endif

include build/rules.make

all-recursive $(STD_TARGETS:=-recursive): dir-check platform-check profile-check

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

dir-check:
	@if [ "$(NO_DIR_CHECK)" = "" -a "$(PROFILE)" != "basic" ]; then echo "Running make from the mcs directory is not supported. Run make from the parent directory."; exit 1; fi

# fun specialty targets

PROFILES = net_2_0 net_3_5 net_4_0

.PHONY: all-profiles $(STD_TARGETS:=-profiles)
all-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
	@:

profiles-do--%:
	$(MAKE) $(PROFILES:%=profile-do--%--$*)

# The % below looks like profile-name--target-name
profile-do--%:
	$(MAKE) PROFILE=$(subst --, ,$*)

# We don't want to run the tests in parallel.  We want behaviour like -k.
profiles-do--run-test:
	ret=:; $(foreach p,$(PROFILES), { $(MAKE) PROFILE=$(p) run-test || ret=false; }; ) $$ret

# Orchestrate the bootstrap here.
_boot_ = all clean install
$(_boot_:%=profile-do--net_4_0--%):           profile-do--net_4_0--%:           profile-do--basic--%
$(_boot_:%=profile-do--net_3_5--%):           profile-do--net_3_5--%:           profile-do--net_2_0--%
$(_boot_:%=profile-do--moonlight--%):         profile-do--moonlight--%:         profile-do--moonlight_raw--%
$(_boot_:%=profile-do--monodroid--%):         profile-do--monodroid--%:         profile-do--basic--%
$(_boot_:%=profile-do--monotouch--%):         profile-do--monotouch--%:         profile-do--basic--%
$(_boot_:%=profile-do--moonlight_raw--%):     profile-do--moonlight_raw--%:     profile-do--basic--%
$(_boot_:%=profile-do--net_2_0--%):           profile-do--net_2_0--%:           profile-do--basic--%

testcorlib:
	@cd class/corlib && $(MAKE) test run-test

compiler-tests:
	$(MAKE) TEST_SUBDIRS="tests errors" run-test-profiles

package := mcs-$(VERSION)

DISTFILES = \
	AUTHORS			\
	ChangeLog		\
	COPYING			\
	COPYING.LIB		\
	INSTALL.txt		\
	LICENSE			\
	LICENSE.GPL		\
	LICENSE.LGPL		\
	LICENSE.MPL		\
	Makefile		\
	mkinstalldirs		\
	MIT.X11			\
	MonoIcon.png		\
	README			\
	ScalableMonoIcon.svg	\
	winexe.in

dist-local: dist-default

csproj-local:

dist-pre:
	rm -rf $(package)
	mkdir $(package)

dist-tarball: dist-pre
	$(MAKE) distdir='$(package)' dist-recursive
	tar cvjf $(package).tar.bz2 $(package)

dist: dist-tarball
	rm -rf $(package)

# the egrep -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck: dist-tarball
	rm -rf InstallTest Distcheck-MCS ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	mv $(package) Distcheck-MCS ; \
	(cd Distcheck-MCS && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MCS $(package) ; \
	tar tjf $(package)/$(package).tar.bz2 |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.bz2 ; \
	tar tjf $(package).tar.bz2 |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |egrep -v '(makefrag|response)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

monocharge:
	chargedir=monocharge-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) install DESTDIR="$$DESTDIR" || exit 1 ; \
	tar cvjf "$$chargedir".tar.bz2 "$$chargedir" ; \
	rm -rf "$$chargedir"

# A bare-bones monocharge.

monocharge-lite:
	chargedir=monocharge-lite-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) -C mcs install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/corlib install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System.XML install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/Mono.CSharp.Debugger install DESTDIR="$$DESTDIR" || exit 1; \
	tar cvjf "$$chargedir".tar.bz2 "$$chargedir" ; \
	rm -rf "$$chargedir"

=== mcs/docs/Makefile ===
thisdir = docs
SUBDIRS = 
include ../build/rules.make

DISTFILES = \
	clr-abi.txt                 \
	compiler.txt                \
	control-flow-analysis.txt   \
	cs-errors.config            \
	monodoc.xml                 \
	new-anonymous-design.txt    \
	order.txt                   \
	$(DOC_SOURCE_FILES)         \
	$(wildcard ecma334/*.xml)

DOC_SOURCE_FILES = \
	lang-csharp.source          \
	Mono.source                 \
	netdocs.source              \
	Novell.source

ASSEMBLED_DOCS = \
	cs-errors.tree cs-errors.zip      \
	ecma334.tree ecma334.zip          \
	Mono.tree Mono.zip                \
	netdocs.tree netdocs.zip          \
	Novell.tree Novell.zip            

MONODOC_SOURCES_INSTALL_FILES = \
	$(ASSEMBLED_DOCS)             \
	$(DOC_SOURCE_FILES)

CLEAN_FILES += $(ASSEMBLED_DOCS)

ifeq (net_4_0, $(PROFILE))
all-local: build-documentation
endif

all-local csproj-local test-local run-test-local run-test-ondotnet-local doc-update:

clean-local:
	-rm -f $(CLEAN_FILES)

dist-local: dist-default


MONODOC_INSTALL_DIR = $(DESTDIR)$(mono_libdir)/monodoc

ifdef DISABLE_MCS_DOCS
install-local:

uninstall-local:

else
install-local:
	$(MKINSTALLDIRS) $(MONODOC_INSTALL_DIR) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) $(MONODOC_SOURCES_INSTALL_FILES) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) monodoc.xml $(MONODOC_INSTALL_DIR)

uninstall-local:
	-rm -f $(MONODOC_INSTALL_DIR)/monodoc.xml
	-rm -f $(addprefix $(MONODOC_INSTALL_DIR)/sources/,$(MONODOC_SOURCES_INSTALL_FILES))
endif



classdir = $(topdir)/class
doc_en   = Documentation/en

NETDOCS_DIRS = \
	$(classdir)/corlib/$(doc_en)                                        \
	$(classdir)/Microsoft.Build.Engine/$(doc_en)                        \
	$(classdir)/Microsoft.Build.Framework/$(doc_en)                     \
	$(classdir)/Microsoft.Build.Utilities/$(doc_en)                     \
	$(classdir)/System.Configuration.Install/$(doc_en)                  \
	$(classdir)/System.Core/$(doc_en)                                   \
	$(classdir)/System.Data/$(doc_en)                                   \
	$(classdir)/System.Design/$(doc_en)                                 \
	$(classdir)/System.DirectoryServices/$(doc_en)                      \
	$(classdir)/System.Drawing/$(doc_en)                                \
	$(classdir)/System.Runtime.Remoting/$(doc_en)                       \
	$(classdir)/System.Runtime.Serialization.Formatters.Soap/$(doc_en)  \
	$(classdir)/System.Security/$(doc_en)                               \
	$(classdir)/System.Web.Services/$(doc_en)                           \
	$(classdir)/System.Web/$(doc_en)                                    \
	$(classdir)/System.XML/$(doc_en)                                    \
	$(classdir)/System/$(doc_en)                                        \

MONO_DIRS = \
	$(classdir)/Commons.Xml.Relaxng/$(doc_en)          \
	$(classdir)/Mono.Cairo/$(doc_en)                   \
	$(classdir)/Mono.Options/$(doc_en)                 \
	$(classdir)/Mono.Posix/$(doc_en)                   \
	$(classdir)/Mono.Security.Win32/$(doc_en)          \
	$(classdir)/Mono.Security/$(doc_en)                \
	$(classdir)/Mono.Simd/$(doc_en)                    \
	$(classdir)/Mono.CSharp/$(doc_en)                  \
	$(classdir)/Npgsql/$(doc_en)                       \
	$(classdir)/Mono.Debugger.Soft/$(doc_en)

NOVELL_DIRS = \
	$(topdir)/class/Novell.Directory.Ldap/Documentation/en

NUNIT_DIRS = \
	$(topdir)/nunit20/core/$(doc_en)       \
	$(topdir)/nunit20/framework/$(doc_en)  \
	$(topdir)/nunit20/mocks/$(doc_en)      \
	$(topdir)/nunit20/util/$(doc_en)

ifdef DISABLE_MCS_DOCS
build-documentation:
else
build-documentation: $(ASSEMBLED_DOCS)
endif

# To support `make -jN`, we can't mention multiple targets in the same rule;
# DO NOT DO THIS:
#
#	  foo.tree foo.zip : Makefile
#     $(MDOC) assemble -o foo $(FOO_DIRS)
#
# If you do, make will try to biuld foo.tree & foo.zip concurrently, which
# breaks things badly... (read: "mdoc: sharing violation on path...foo.zip").
#
# The proper solution is to chain the rule dependencies so that only one file
# is the target of a rule.

netdocs.zip : netdocs.tree
netdocs.tree: Makefile
	$(MDOC) assemble -o netdocs $(NETDOCS_DIRS)

Mono.zip : Mono.tree
Mono.tree: Makefile
	$(MDOC) assemble -o Mono $(MONO_DIRS)

Novell.zip : Novell.tree
Novell.tree: Makefile
	$(MDOC) assemble -o Novell $(NOVELL_DIRS)

cs-errors.zip : cs-errors.tree
cs-errors.tree: cs-errors.config Makefile
	$(MDOC) assemble -o cs-errors -f error $<

ecma334.zip : ecma334.tree
ecma334.tree: Makefile
	$(MDOC) assemble -o ecma334 -f ecmaspec ecma334

=== mcs/ilasm/Makefile ===
thisdir = ilasm
SUBDIRS =
include ../build/rules.make

PROGRAM = $(topdir)/class/lib/$(PROFILE)/ilasm.exe
BUILT_SOURCES = ILParser.cs
LOCAL_MCS_FLAGS = /lib:../class/lib/$(PROFILE) /r:../class/lib/$(PROFILE)/PEAPI.dll /r:Mono.CompilerServices.SymbolWriter.dll /r:Mono.Security.dll

CLEAN_FILES = parser/y.output

EXTRA_DISTFILES = \
	parser/ILParser.jay	\
	parser/ChangeLog	\
	scanner/ChangeLog	\
	tests/ChangeLog		\
	$(wildcard tests/*.il)

ILParser.cs: parser/ILParser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ct < $(topdir)/jay/skeleton.cs $(CURDIR)/$< >$@

include ../build/executable.make

ifeq (net_1_1, $(PROFILE))
# Utility rule to make debugging somewhat easier.
all-local: ilasm.exe
ilasm.exe: $(PROGRAM)
	cp -p $< $@
	test ! -f $<.mdb || cp -p $<.mdb $@.mdb
endif

=== mcs/tools/Makefile ===
thisdir = tools

per_profile_dirs = \
	al		\
	compiler-tester	\
	linker		\
	tuner		\
	csharp		\
	culevel		\
	genxs		\
	mkbundle	\
	monop		\
	mono-service	\
	mono-xsd	\
	resgen		\
	wsdl		\
	xbuild

net_4_0_dirs := \
	$(per_profile_dirs) \
	corcompare	\
	mono-xmltool	\
	mono-shlib-cop	\
	sgen		\
	mconfig		\
	installutil	\
	nunitreport	\
	pdb2mdb		\
	sqlsharp	\
	sqlmetal	\
	svcutil		\
	ictool		\
	disco		\
	soapsuds	\
	browsercaps-updater	\
	cil-strip	\
	macpack		\
	dtd2rng		\
	dtd2xsd		\
	mod		\
	installvst	\
	lc		\
	mono-configuration-crypto \
	ccrewrite

net_2_0_dirs := \
	$(per_profile_dirs) \
	monodoc		\
	mdoc		\
	compiler-tester

moonlight_dirs := \
	compiler-tester

basic_SUBDIRS = gacutil resgen security culevel
net_2_0_SUBDIRS := $(basic_SUBDIRS) $(net_2_0_dirs)
moonlight_raw_SUBDIRS := $(moonlight_dirs)
moonlight_SUBDIRS := $(moonlight_dirs)
net_4_0_SUBDIRS := $(net_4_0_dirs) $(basic_SUBDIRS)

SUBDIRS = $(basic_SUBDIRS) $(net_2_0_SUBDIRS) $(moonlight_SUBDIRS)
DIST_SUBDIRS = $(SUBDIRS) $(net_4_0_dirs)

include ../build/rules.make

DISTFILES = \
	assemblies.xml			\
	mono-win32-setup-dark.bmp	\
	mono-win32-setup-light.bmp	\
	mono-win32-setup.nsi		\
	scan-tests.pl			\
	tinderbox/smtp.c		\
	tinderbox/tinderbox.sh		\
	removecomments.sh

test-local csproj-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local doc-update-local:
	@:

dist-local: dist-default

clean-local:
	rm -f *.exe *.dll *.pdb cormissing.xml

=== mcs/class/IBM.Data.DB2/Makefile ===
thisdir = class/IBM.Data.DB2
SUBDIRS =
include ../../build/rules.make

LIBRARY = IBM.Data.DB2.dll
LIB_MCS_FLAGS = /unsafe /r:$(corlib) /r:System.dll \
	/r:System.Xml.dll /r:System.Data.dll
NO_TEST = yes

EXTRA_DISTFILES = ibm.pub

include ../../build/library.make

=== mcs/class/Microsoft.Build.Engine/Makefile ===
thisdir = class/Microsoft.Build.Engine
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.Build.Engine.dll

BUILD_FRAMEWORK = Microsoft.Build.Framework.dll

ifeq (3.5, $(FRAMEWORK_VERSION))
NAME_SUFFIX = .v3.5
BUILD_FRAMEWORK := $(topdir)/class/lib/$(PROFILE)/$(BUILD_FRAMEWORK)
else
ifeq (4.0, $(FRAMEWORK_VERSION))
NAME_SUFFIX = .v4.0
endif
endif

LIB_MCS_FLAGS = \
	/r:$(corlib)				\
	/r:System.dll				\
	/r:System.Core.dll		\
	/r:System.Xml.dll			\
	/r:$(BUILD_FRAMEWORK)			\
	/r:Microsoft.Build.Utilities$(NAME_SUFFIX).dll

TEST_MCS_FLAGS = \
	/r:$(BUILD_FRAMEWORK)	\
	/r:Microsoft.Build.Utilities$(NAME_SUFFIX).dll

EXTRA_DISTFILES = \
	Test/resources/TestTasks.cs		\
	Test/resources/*.*proj	\
	Test/test-config-file*

Test/resources/TestTasks.dll: Test/resources/TestTasks.cs
	$(CSCOMPILE) Test/resources/TestTasks.cs /r:Microsoft.Build.Framework.dll /r:Microsoft.Build.Utilities$(NAME_SUFFIX).dll /target:library

clean-local: clean-test-tasks

clean-test-tasks:
	rm -f Test/resources/TestTasks.dll	

test-local: copy-config

ifeq (net_4_0, $(PROFILE))
copy-config:
	cp Test/test-config-file-net-4.0 $(test_lib).config
else
ifeq (net_3_5, $(PROFILE))
copy-config:
	cp Test/test-config-file-net-3.5 $(test_lib).config
else
copy-config:
endif
endif

export TESTING_MONO=a
XBUILD_DIR=../../tools/xbuild
include $(XBUILD_DIR)/xbuild_targets.make

test-local: Test/resources/TestTasks.dll

include ../../build/library.make

=== mcs/class/Microsoft.Build/Makefile ===
thisdir = class/Microsoft.Build
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.Build.dll

ifneq (4.0, $(FRAMEWORK_VERSION))
LIBRARY_NAME = dummy-Microsoft.Build.dll
NO_INSTALL = yes
NO_TEST = yes
NO_SIGN_ASSEMBLY = yes
endif

LIB_MCS_FLAGS = \
	/r:$(corlib)				\
	/r:System.dll				\
	/r:System.Core.dll			\
	/r:System.Xml.dll			\
	/r:Microsoft.Build.Engine.dll		\
	/r:Microsoft.Build.Framework.dll

include ../../build/library.make

export TESTING_MONO=a
XBUILD_DIR=../../tools/xbuild
include $(XBUILD_DIR)/xbuild_targets.make

=== mcs/class/Microsoft.Web.Infrastructure/Makefile ===
thisdir = class/Microsoft.Web.Infrastructure
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.Web.Infrastructure.dll
LIB_MCS_FLAGS = -r:System.dll \
		-r:System.Configuration.dll \
		-r:System.Web.dll

EXTRA_DISTFILES = $(RESOURCE_FILES)

VALID_PROFILE := $(filter 4.0, $(FRAMEWORK_VERSION))
ifndef VALID_PROFILE
LIBRARY_NAME = dummy-Microsoft.Web.Infrastructure.dll
NO_INSTALL = yes
NO_SIGN_ASSEMBLY = yes
NO_TEST = yes
endif

include ../../build/library.make

=== mcs/class/Mono.C5/Makefile ===
thisdir = class/Mono.C5
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.C5.dll
LIBRARY_SNK = c5.snk
LIB_MCS_FLAGS = /r:$(corlib) /r:System.dll -nowarn:169
TEST_MCS_FLAGS = $(LIB_MCS_FLAGS) -nowarn:0618 -nowarn:219 -nowarn:169

EXTRA_DISTFILES = \
	LICENSE.txt \
	c5.pub c5.snk c5.xml

include ../../build/library.make

=== mcs/class/Mono.Cecil/Makefile ===
thisdir = class/Mono.Cecil
include ../../build/rules.make

LIBRARY = Mono.Cecil.dll
LIBRARY_SNK = ../mono.snk
LIBRARY_PACKAGE = none

LIB_MCS_FLAGS = /r:$(corlib) -keyfile:$(LIBRARY_SNK) -r:System.Core.dll -d:NET_3_5

ifeq (net_4_0, $(PROFILE))
LIB_MCS_FLAGS += -d:NET_4_0
endif

NO_TEST = yes

ifneq (net_2_0, $(PROFILE))
NO_INSTALL = yes
endif

include ../../build/library.make

=== mcs/class/Mono.CodeContracts/Makefile ===
thisdir = class/Mono.CodeContracts
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.CodeContracts.dll

LIB_MCS_FLAGS = -r:System -r:System.Core -r:Mono.Cecil.dll -r:Mono.Cecil.Mdb.dll 
#-r:Mono.Cecil.Pdb.dll

include ../../build/library.make

=== mcs/class/Mono.CompilerServices.SymbolWriter/Makefile ===
thisdir = class/Mono.CompilerServices.SymbolWriter
SUBDIRS =
include ../../build/rules.make

LIBRARY = Mono.CompilerServices.SymbolWriter.dll
LIBRARY_USE_INTERMEDIATE_FILE = yes

LIB_MCS_FLAGS = /r:System.dll
NO_TEST = yes

ifneq (basic, $(PROFILE))
USE_BOOT_COMPILE = yes
endif

ifdef USE_BOOT_COMPILE
LIBRARY_COMPILE = $(BOOT_COMPILE)
endif

include ../../build/library.make

=== debian/changelog ===
mono (2.10.8.1-8+deb7u1) wheezy-security; urgency=high

  * [c2afe08] Mono's implementation of the SSL/TLS stack failed to check
    the order of the handshake messages. Which would allow various attacks
    on the protocol to succeed. ("SKIP-TLS" attack).
    (Closes: #780751, CVE-2015-2318)
  * [997bd08] Remove the client-side SSLv2 fallback. There's almost no
    SSLv3 web site left so a v2 fallback is only extra code we do not
    need to carry forward. (Closes: #780751, CVE-2015-2320)
  * [b570325] Remove the EXPORT ciphers and related code path. That was
    still useful in 2003/2004 but the technical and legal landscape changed
    a lot since then. Removing the old, limited key size, cipher suites
    also allow removed additional parts of the code that deals with them.
    ("FREAK" attack) (Closes: #780751, CVE-2015-2319)

 -- Jo Shields <jo.shields@xamarin.com>  Thu, 19 Mar 2015 11:32:12 +0000

mono (2.10.8.1-8) unstable; urgency=high

  * [b9108c7] Dirty patch to introduce a new System.Windows.Forms.WebBrowser 
    back-end, which does absolutely nothing. This is to allow applications 
    which create a WebBrowser object to continue to run without crashing, 
    in the absence of a working browser back-end (which we lack right now). 
    This patch is sufficient for 
    http://www.java2s.com/Tutorial/CSharp/0460__GUI-Windows-Forms/AsimpleBrowser.htm 
    to run without crashing. (Closes: #683289, #694948)

 -- Jo Shields <directhex@apebox.org>  Sun, 03 Mar 2013 17:36:38 +0000

mono (2.10.8.1-7) unstable; urgency=high

  [ Jo Shields ]
  * [4a46aae] Remove armhf from mono-archs.make - It should have been 
    removed in 2.10.8.1-6 but was overlooked (Closes: #695743)

  [ Marek Habersack ]
  * [226b326] Fix for Novell bug #739119 (Closes: #686562, CVE-2012-3543)
  * [6983b45] Update to fix for Novell bug #739119

 -- Jo Shields <directhex@apebox.org>  Mon, 28 Jan 2013 10:27:00 +0000

mono (2.10.8.1-6) unstable; urgency=low

  * [da2fc97] Remove armhf from list of supported architectures. It 
    ain't supported by the runtime in Mono 2.10.x, and trying to 
    shoehorn it in was more difficult than we had hoped. It will 
    return in the future, for Mono 2.12. (Closes: #682284)

 -- Jo Shields <directhex@apebox.org>  Mon, 27 Aug 2012 17:15:03 +0100

mono (2.10.8.1-5) unstable; urgency=high

  [ Jo Shields ]
  * [c05ec16] Add symbols file for ppc64 (Closes: #651664)

  [ Mirco Bauer ]
  * [4e87058] Fixed version of ppc64 specific symbol
    mono_exc_esp_offset was introduced in 2.10.1 which is also 
    backport-friendly

  [ Gonzalo Paniagua Javier ]
  * [1930eb3] HtmlEncode the path.
    	Fixes Novell bug #769799. (Closes: #681095, CVE-2012-3382)

 -- Jo Shields <directhex@apebox.org>  Wed, 11 Jul 2012 19:13:12 +0100

mono (2.10.8.1-4) unstable; urgency=low

  [ Iain Lane ]
  * [10b15d4] Pass LDFLAGS to binfmt-detector-cli too (Closes: #657518)

  [ Jo Shields ]
  * [f77ef2f] Tweak build system to check multiarch library folder for 
    libX11.so.

 -- Jo Shields <directhex@apebox.org>  Sun, 27 May 2012 15:28:00 +0100

mono (2.10.8.1-3) unstable; urgency=low

  * [c934e01] Remove unused File::Basename import from runtime script.
    Having this present causes failures on release upgrades where perl-base
    and perl-modules are not in a consistent state (e.g. this can happen
    when upgrading across major Perl versions). (Closes: #665335) (LP:
    #948848)
  * [9e3cc40] Remove monodoc-base trigger.
    This trigger updated the monodoc search index. It ended up calling
    /usr/bin/monodoc, which is shipped in the monodoc-browser package
    (source package mono-tools). The script attempted to check that
    monodoc-browser was configured, but didn't get this right. This led to
    numerous upgrade failures when Depends of monodoc-browser were not
    satisfied when the trigger was invoked and calling monodoc to update the
    search index bombed out due to this. It's more correct to just have
    monodoc-browser ship this trigger itself. (LP: #972751)
  * [dd2925c] Standards-Version bump to 3.9.3, no changes required
  * [8299ee0] Remove duplicate Depends in mono-complete
  * [508c4f5] Revert "Merge branch 'master-patches/fix_crash_in_fixup_cattrs'"
    This reverts commit 86127dcf508213eac5b50a65c989cf5971b57378, reversing
    changes made to 55a1a20a4d858346ed8a8d840abc3f9230ea816e.
    This branch introduced regressions which caused both nant and mono-upnp
    (at least) to FTBFS. (Closes: #666623)
  * [61fbbe4] Fix ARM printf format problems.
    When building with -Werror=format-security on ARM, mono fails to build
    due to incorrect format strings in arm-dis.c
    (cherry picked from commit 32c1b70ad164640ff0a2739e66884d0279cfe7c7)
    Signed-off-by: Iain Lane <laney@debian.org>
  * [9883116] Pass CFLAGS and CPPFLAGS when building binfmt-detector.
    Ensures hardening support is enabled for this binary.
    Thanks to Simon Ruderich <simon@ruderich.org> (Closes: #657518)
  * [4bb0138] Ensure compiler flags are passed into build system.
    This issue was discovered when it was noted that Debian's hardening
    buildflags weren't being propogated to all binaries.
    The patch is from Simon Ruderich <simon@ruderich.org>
    (cherry picked from commit d6dcfb27fc6252352f6ad6f8bd9ef5cff206fd46)
    Also Closes: #657518

 -- Iain Lane <laney@debian.org>  Wed, 04 Apr 2012 21:15:59 +0100

mono (2.10.8.1-2) unstable; urgency=low

  [ Zoltan Varga ]
  * [52cf3ab] Modify fixup_cattrs () to handle a corner case where a cattr is
              created using a MonoCMethod instead of a ConstructorBuilder.

  [ Moritz Muehlenhoff ]
  * [96d7d4a] Use dpkg-buildflags for enabling hardened build flags
              (closes: #657518)

  [ Mirco Bauer ]
  * [de40c42] Bumped dpkg-dev build-dep to >= 1.16.1~ as we include
              buildflags.mk of it

 -- Mirco Bauer <meebey@debian.org>  Thu, 22 Mar 2012 22:00:34 +0100

mono (2.10.8.1-1) unstable; urgency=low

  [ Jb Evain ]


=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Debian Mono Group <pkg-mono-group@lists.alioth.debian.org>
Uploaders: Mirco Bauer <meebey@debian.org>, Jo Shields <directhex@apebox.org>
Build-Depends: debhelper (>= 7),
	dpkg-dev (>= 1.16.1~),
	bison,
	libtool,
	libxml-dom-perl,
	libxslt1-dev,
	dc,
	lsb-release,
	libx11-dev,
	libxt-dev,
	zlib1g-dev,
	autoconf,
	automake
Standards-Version: 3.9.3
Homepage: http://www.mono-project.com/
Vcs-Git: git://git.debian.org/git/pkg-mono/packages/mono.git
Vcs-Browser: http://git.debian.org/?p=pkg-mono/packages/mono.git

Package: mono-runtime
Provides: cli-runtime, cli-virtual-machine
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Replaces: mono-common (<< 2.4), mono-jit (<< 2.4), libmono0 (<< 2.4)
Conflicts: mono-common (<< 2.4),
           mono-jit (<< 2.4),
           mono-1.0-runtime (<< 2.4),
           mono-2.0-runtime (<< 2.4)
Suggests: xdg-utils | libgnome2-0 | konqueror
Recommends: binfmt-support (>= 1.1.2)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-gac (= ${source:Version})
Description: Mono runtime
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono".
 "mono" executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, SPARC, S/390, AMD64 and
 IA64 architectures. Optionally this package configures BINFMT support.

Package: mono-runtime-sgen
Architecture: amd64 armel i386 kfreebsd-amd64 kfreebsd-i386 s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-runtime (= ${binary:Version})
Homepage: http://www.mono-project.com/Compacting_GC
Description: Mono runtime - SGen (experimental)
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, SPARC, S/390, AMD64 and
 IA64 architectures.
 .
 This package uses SGen which is Mono's new simple generational garbage
 collector instead of Boehm's conservative garbage collector. SGen is
 currently only for testing and thus should not be used in production.

Package: mono-runtime-dbg
Priority: extra
Section: debug
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Replaces: mono-jit-dbg (<< 2.4)
Conflicts: mono-jit-dbg (<< 2.4)
Depends: ${misc:Depends}, mono-runtime (= ${binary:Version})
Recommends: gdb
Description: Mono runtime, debugging symbols
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the debugging symbols of the Mono JIT/AOT compiler.

Package: mono-utils
Provides: cil-disassembler
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Replaces: mono-mcs (<= 1.1.6-4)
Depends: ${shlibs:Depends}, ${misc:Depends}, libmono-2.0-1 (= ${binary:Version}),
 libmono-corlib4.0-cil (= ${source:Version}) | libmono-corlib2.0-cil (= ${source:Version})
Description: Mono utilities
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package includes various tools useful for CLI developers, like
 pedump, monodis and monograph.

Package: mono-complete
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Depends: ${misc:Depends},
         mono-runtime (= ${binary:Version}),
         mono-runtime-sgen (= ${binary:Version}) [amd64 armel i386 kfreebsd-amd64 kfreebsd-i386 s390x],
         libmono-2.0-1 (= ${binary:Version}),
         libmono-profiler (= ${binary:Version}),
         mono-utils (= ${binary:Version}),
         mono-jay (= ${binary:Version}),
         mono-devel (= ${source:Version}),
         mono-mcs (= ${source:Version}),
         mono-gmcs (= ${source:Version}),
         mono-dmcs (= ${source:Version}),
         mono-csharp-shell (= ${source:Version}),
         mono-2.0-gac (= ${source:Version}),
         mono-4.0-gac (= ${source:Version}),
         mono-2.0-service (= ${source:Version}),
         mono-4.0-service (= ${source:Version}),
         monodoc-base (= ${source:Version}),
         monodoc-manual (= ${source:Version}),
         libmono-cil-dev (= ${source:Version})
Description: complete Mono runtime, development tools and all libraries
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This is a metapackage and pulls in the Mono runtime, development tools and
 all libraries.
 .
 Install this package if you want to run software for Mono or Microsoft .NET
 which you are not installing from a Debian package.
 .
 For packagers: This package is not to be used as dependency for packages!
 You should build-depend on cli-common-dev and the needed libraries instead.

Package: libmono-2.0-1
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Replaces: libmono-dev (<= 1.1.6-4)
Conflicts: mono-utils (<< 1.2.3.1-4)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mono JIT library
 Shared library for Mono, used for embedding/hosting of the JIT.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-2.0-1-dbg
Priority: extra
Section: debug
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Depends: ${misc:Depends}, libmono-2.0-1 (= ${binary:Version})
Recommends: gdb
Description: Mono JIT library, debugging symbols
 This package contains the debugging symbols of the Mono JIT library.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-2.0-dev
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Depends: ${misc:Depends}, libmono-2.0-1 (= ${binary:Version})
Description: Mono JIT library - Development files
 Header files and static libraries for libmono-2.0.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-profiler
Architecture: amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 s390x sparc
Replaces: mono-runtime (<< 2.4.2.3)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mono profiler libraries
 Profiler libraries for Mono, used for profiling applications running on Mono.
 For details how to use them, please take a look at the mono manpage.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Novell.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-cil-dev
Architecture: all
Replaces: libmono-nunit2.2-cil (<< 2.4.3),
          libmono-nunit2.4-cil (<< 2.4.3),
          libmono-cairo2.0-cil (<< 2.4.3),
          libmono-cecil-private-cil (<< 2.4.3),
          libmono-system-web2.0-cil (<< 2.4.3),
          libmono-wcf3.0-cil (<< 2.4.3),
          libmono2.0-cil (<< 2.4.3),
          mono-devel (<< 2.4.3),
          libmono-dev (<< 2.10~)
Breaks: libmono-dev (<< 2.10~)
Conflicts: libmono-nunit2.2-cil,
           libmono-nunit2.4-cil
Depends: ${misc:Depends},
         libmono2.0-cil (= ${source:Version}),
         libmono-accessibility2.0-cil (= ${source:Version}),
         libmono-accessibility4.0-cil (= ${source:Version}),
         libmono-c5-1.1-cil (= ${source:Version}),
         libmono-cairo2.0-cil (= ${source:Version}),
         libmono-cairo4.0-cil (= ${source:Version}),
         libmono-cecil-private-cil (= ${source:Version}),
         libmono-codecontracts4.0-cil (= ${source:Version}),
         libmono-compilerservices-symbolwriter4.0-cil (= ${source:Version}),
         libmono-corlib2.0-cil (= ${source:Version}),
         libmono-corlib4.0-cil (= ${source:Version}),
         libmono-cscompmgd8.0-cil (= ${source:Version}),
         libmono-csharp4.0-cil (= ${source:Version}),
         libmono-custommarshalers4.0-cil (= ${source:Version}),
         libmono-data-tds2.0-cil (= ${source:Version}),
         libmono-data-tds4.0-cil (= ${source:Version}),
         libmono-db2-1.0-cil (= ${source:Version}),
         libmono-debugger-soft2.0-cil (= ${source:Version}),
         libmono-debugger-soft4.0-cil (= ${source:Version}),
         libmono-http4.0-cil (= ${source:Version}),
         libmono-i18n2.0-cil (= ${source:Version}),
         libmono-i18n4.0-all (= ${source:Version}),
         libmono-i18n-west2.0-cil (= ${source:Version}),
         libmono-ldap2.0-cil (= ${source:Version}),
         libmono-ldap4.0-cil (= ${source:Version}),
         libmono-management2.0-cil (= ${source:Version}),
         libmono-management4.0-cil (= ${source:Version}),
         libmono-messaging2.0-cil (= ${source:Version}),
         libmono-messaging4.0-cil (= ${source:Version}),
         libmono-messaging-rabbitmq2.0-cil (= ${source:Version}),
         libmono-messaging-rabbitmq4.0-cil (= ${source:Version}),
         libmono-microsoft8.0-cil (= ${source:Version}),
         libmono-microsoft-build2.0-cil (= ${source:Version}),
         libmono-microsoft-build-engine4.0-cil (= ${source:Version}),
         libmono-microsoft-build-framework4.0-cil (= ${source:Version}),
         libmono-microsoft-build-tasks-v4.0-4.0-cil (= ${source:Version}),
         libmono-microsoft-build-utilities-v4.0-4.0-cil (= ${source:Version}),
         libmono-microsoft-csharp4.0-cil (= ${source:Version}),
         libmono-microsoft-visualc10.0-cil (= ${source:Version}),

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include debian/mono-archs.make

# Assume Debian behaviour by default.
DISTRO = $(shell lsb_release -si)

MAKEFILE = $(firstword $(MAKEFILE_LIST))
DEBIAN_DIR = $(dir $(MAKEFILE))
SOURCE_DIR = $(DEBIAN_DIR)/..

VERSION = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Vers | cut -d\  -f2)
UPVERSION = $(shell echo $(VERSION) | sed 's,-.*,,' | sed 's,+dfsg.*,,')
NEXT_UPVERSION = $(shell perl -e '$$_=pop; s/(\d+)$$/$$1+1/e; print' $(UPVERSION))
DEB_SOURCE_NAME = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Source | cut -d" " -f2)

RUN_MONO = LD_LIBRARY_PATH=debian/tmp/usr/lib MONO_PATH=debian/tmp/usr/lib/mono/4.0 debian/tmp/usr/bin/mono
DH_INTERNAL_MONO_PARAM = --internal-mono
ifeq ($(shell dpkg --compare-versions $$(dpkg-query -f '$${Version}' -W debhelper) lt 7.1; echo $$?), 0)
	DH_INTERNAL_MONO_PARAM = internal-mono
endif

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONF_FLAGS += --build $(DEB_HOST_GNU_TYPE)
else
	CONF_FLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
        CONF_FLAGS += --enable-minimal=aot
endif

ifeq ($(DEB_BUILD_ARCH), armel)
	CONF_FLAGS += --with-fpu=NONE
endif
ifeq ($(DEB_BUILD_ARCH), powerpc)
	# libgc with parallel mark FTBFS on ppc
	CONF_FLAGS += --disable-parallel-mark
endif

ifneq (,$(findstring $(DEB_BUILD_ARCH),$(DEB_MONO_SGEN_ARCHS)))
	CONF_FLAGS += --with-sgen=yes
else
	CONF_FLAGS += --with-sgen=no
endif

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	MINI_TEST = true
	MONO_BOEHM_TEST = true
	MONO_SGEN_TEST = true
else
	MINI_TEST = cd mono/mini && make check
	MONO_BOEHM_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=boehm make test
	MONO_SGEN_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=sgen make test
endif
ifeq ($(DEB_BUILD_ARCH), powerpc)
	MONO_SGEN_TEST = true
endif

MDB_REL = mono-debugger
ifeq ($(DISTRO), Ubuntu)
	MDB_VARS =  -Vmdb:Suggests=$(MDB_REL)
	MDB_VARS += -Vmdb:Recommends=
else
	MDB_VARS =  -Vmdb:Suggests=
	MDB_VARS += -Vmdb:Recommends=$(MDB_REL)
endif

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CONFIGURE =	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"   \
		./configure $(CONF_FLAGS) --prefix=/usr \
		  --mandir=\$${prefix}/share/man \
		  --infodir=\$${prefix}/share/info --sysconfdir=/etc \
		  --with-ikvm-native=no \
		  --disable-quiet-build \
		  --disable-system-aot

# Mono's build system doesn't like -j > 1
MAKE_FLAGS += -j1
export MAKEFLAGS=$(MAKE_FLAGS)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	EGLIB_MAKE_FLAGS += -j$(NUMJOBS)
	LIBGC_MAKE_FLAGS += -j$(NUMJOBS)
	MONO_MAKE_FLAGS += -j$(NUMJOBS)
endif

autoreconf: autoreconf-stamp
autoreconf-stamp:
	autoreconf -f -i -s
	touch $@

configure: configure-stamp
configure-stamp: autoreconf-stamp
	dh_testdir
	$(CONFIGURE)
	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	cd eglib && $(MAKE) $(EGLIB_MAKE_FLAGS)
	cd libgc && $(MAKE) $(LIBGC_MAKE_FLAGS)
	cd mono && $(MAKE) $(MONO_MAKE_FLAGS)
	LC_ALL=C $(MAKE) $(MAKE_FLAGS) EXTERNAL_MCS=false EXTERNAL_MONO=false

	cd debian/detector && \
	  $(MAKE)
	chmod +x debian/dh_makeclilibs \
	         debian/dh_clideps \
	         debian/dh_clistrip \
	         debian/dh_clifixperms \
	         debian/dh_monoaot

	touch $@

test: test-stamp
test-stamp: build-stamp
	-$(MINI_TEST)
	-$(MONO_BOEHM_TEST)
	-$(MONO_SGEN_TEST)
	# funny bug-459094.cs creates too long directory names which
	# pbuilder is unable to remove, eh
	rm -rf mono/tests/abcde12345abcde12345abcde12345abcde12345/
	touch $@

clean:
	echo "distro is $(DISTRO)"
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) distclean
	# distclean misses stuff
	find -name "*.mdb" -delete
	rm -rf mcs/class/lib/basic/ \
	       mcs/class/lib/net_2_0/ \
	       mcs/class/lib/net_3_5/ \
	       mcs/class/lib/net_4_0/

	-cd debian/detector && $(MAKE) clean
	rm -f debian/MonoGetAssemblyName.exe \
	      debian/mono-api-diff.exe

	# clean stuff handled by autoreconf
	rm -rf configure config.sub config.guess aclocal.m4 autom4te.cache/
	find . -name "Makefile.in" -delete

	rm -f autoreconf-stamp
	rm -f configure-*-stamp
	rm -f build-*-stamp
	rm -f install-*-stamp

	dh_clean

install: install-stamp
install-stamp:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	cd mcs/jay && \
		$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	# don't want docs of bundled libgc
	rm -rf debian/tmp/usr/share/libgc-mono
	# Mono.Security.Win32.dll is only useful on windows, as it wrap the win api
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.Security.Win32/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/2.0/Mono.Security.Win32.dll*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.0/Mono.Security.Win32.dll*
	# we don't ship bundled nunit of mono
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/2.0/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.0/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/pkgconfig/mono-nunit.pc
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/nunit*/
	rm -f  $(CURDIR)/debian/tmp/usr/bin/nunit*
	# csharp 2.0 is unneeded as we ship 4.0 already
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.CSharp/2.0.0.0__*/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/2.0/Mono.CSharp.dll*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/2.0/csharp.exe*
	rm -f  $(CURDIR)/debian/tmp/usr/bin/csharp2

	# mono 2.10.1 bug, this lib is really linked against corlib 4.0
	rm -f $(CURDIR)/debian/tmp/usr/lib/mono/2.0/Mono.C5.dll
	# mono 2.10.1 bug, prj2make was removed but the start script not
	rm -f $(CURDIR)/debian/tmp/usr/bin/prj2make
	# mono 2.10.1 bug, this lib doesn't exist for .NET 4.0 and also has
	# a wrong assembly version
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/cscompmgd/0.0.0.0__*/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.0/cscompmgd*

	# copy missing 2.0 manpages
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/al.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/al2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/dmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/monop.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/monop2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/resgen.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/resgen2.1
	touch $@

binary: binary-arch binary-indep

binary-indep: build-stamp install-stamp
	dh_testdir
	dh_testroot

	# Build the late-GAC tool,
	# using the built Mono runtime from debian/tmp
	# (thus the install-arch target dependency!)
	$(RUN_MONO) mcs/class/lib/net_4_0/dmcs.exe \
	  -target:exe \
	  -out:debian/MonoGetAssemblyName.exe \
	  debian/MonoGetAssemblyName.cs

	# Build mono-api-diff
	$(RUN_MONO) mcs/class/lib/net_4_0/dmcs.exe \
	  -target:exe \
	  -out:debian/mono-api-diff.exe \
	  debian/mono-api-diff.cs

	# that exclude list are programs for arch-dep packages
	dh_install -i --list-missing -Xusr/share/man -Xusr/share/jay -Xusr/lib/libmono -Xusr/lib/libMono -Xbin/monodis -Xbin/monograph -Xbin/mono-find-provides -Xbin/mono-find-requires -Xbin/pedump -Xbin/jay

	# Late GAC
	install -D -m 755 debian/mono.runtime-script debian/mono-gac/usr/share/cli-common/runtimes.d/mono
